//
// 24-311: Numerical Methods
// spring.cpp  written by Kenji Shimada
// Problem Set 7 Sample Code 
//

#include  "spring.h"


int main(int argc, char *argv[]) {     

	int		i;
	double	p[MAX_ITER][3];


	cout << "\n>> 24-311:Numerical Methods--2D Unconstrained Optimization <<\n\n";

	// Open output wrl file
	ofstream outFile;                   
	outFile.open ("output.wrl", ios::out);
	if (!outFile) {
		cerr << "Cannot open this file for output.\n";
		exit (-1);
	}


	///////////////////////////////////////////////
	// Write your optimization code here
	///////////////////////////////////////////////
	// Create a dummy path p[][]
	// 
	//   p[][] is a matrix that stores the path 
	//   created by your optimization codes.
	//   For example p[i][0] and p[i][1] are
	//   x and y coordinate values at i-th iteration.
	//   The potential energy E(x,y) can be calculated
	//   by using a predefined function, "energy".
	// 
	//   The following 5 lines are to create a dummy
	//   path just to show you how to define a path.
	//   You have to replace these with your own
	//   optimization code.

	for (i=0; i<15; i++) {
		p[i][0] = i/100.0;
		p[i][1] = i/100.0 + sin(i)/30.0;
		p[i][2] = energy(p[i][0], p[i][1]);
	}



	// Create the canvas in the output file
	vrml_surface (outFile, MY_NAME);

	// Draw the path
	vrml_path (outFile, 15, p);
	
	// Close the output wrl file
	outFile.close ();

	cout.flush();
	return 0;
}


double energy(double x, double y) {
// This function calculates the energy
// This function is NOT correct.
// You have to replace it.

	return  K1 * pow( sqrt( pow(L1 - x,2) + pow(y,2)) - L2, 2) /3.0
		   + K2 * pow( sqrt( pow(L2 - x,2) + pow(y,2)) - L1, 2) /3.0
		   - 0.5 * P1 * x - 0.5 * P2 * y;
}

