//
// spring.h  written by Kenji Shimada,
// Problem Set 7 Sample Code 
//

#ifndef SPRING_H
#define SPRING_H


#include <stdlib.h>
#include <math.h>
#include <iostream.h>
#include <fstream.h>


// Constant Definitions 
#define	MY_NAME     "Kenji Shimada (shimada@cmu.edu)"
#define MAX_ITER	(100)
#define	K1			(800)
#define	K2			(100)
#define	L1			(0.1)
#define L2			(0.1)
#define P1			(5)
#define P2			(5) 

#define DRAW_WIDTH	(0.2)
#define SURF_PREC	(20)
#define X_SPACING   (1.0)
#define Y_SPACING	(1.0)

// Function Prototypes 
void	vrml_surface (ofstream &outFile, char* my_name);   
void	vrml_path (ofstream &outFile, int n, double p[][3]);
double	energy (double x, double y);


#endif SPRING_H

